
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《WebGL入门指南》——第2章，第2.4节一个真实的3D示例 / iVAN</title>

    <meta name="description" content="《WebGL入门指南》——第2章，第2.4节一个真实的3D示例 2.4 一个真实的3D示例 WebGL入门指南 到目前为止,你也许在想&quot;真是个还不错的正方形&quot;,然后开始怀疑我们什么时候开始画一些真正的3D图形.好吧,那就现在吧!在示例2-2中我们将会用更有趣的物体来代替正方形,我们将会完成一个看起来还不错.并且展示了大部分WebGL主要特性.同时还保持代码简洁的页面. 图2-2就是页面的最终效果.其中我们设置了标题文字,添加了一个表面贴有图片的立方体,然后在页面底部也添加了文字.另外值得一提的是,这个页面是可以交互的:点击画布元素,立方体 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《WebGL入门指南》——第2章，第2.4节一个真实的3D示例</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>2.4　一个真实的3D示例</strong><br />
WebGL入门指南<br />
到目前为止，你也许在想“真是个还不错的正方形”，然后开始怀疑我们什么时候开始画一些真正的3D图形。好吧，那就现在吧！在示例2-2中我们将会用更有趣的物体来代替正方形，我们将会完成一个看起来还不错、并且展示了大部分WebGL主要特性、同时还保持代码简洁的页面。</p>
<p>图2-2就是页面的最终效果。其中我们设置了标题文字，添加了一个表面贴有图片的立方体，然后在页面底部也添加了文字。另外值得一提的是，这个页面是可以交互的：点击画布元素，立方体就会开始或停止旋转。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2EyM2QwNDY5MmRiOTI1YTFlOTYyMzJlNDU0N2RmZDljNjI4YjM3OTYucG5n.jpg"></p>
<p>图2-2　一个进阶的Three.js示例，纹理图像来自http://www.openclipart.org（CC Public Domain Dedication授权使用）</p>
<p>让我们详细看一下这一切是如何完成的。下面是示例2-2的完整代码。这比我们的第一个Three.js示例要复杂一些，但是依然足够简洁，我们可以快速地浏览一下整个代码。</p>
<p>示例2-2　欢迎来到WebGL！</p>
<pre><code>&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
&lt;title&gt;Welcome to WebGL&lt;/title&gt;
     &lt;link rel="stylesheet" href="../css/webglbook.css" /&gt;
     &lt;script src="../libs/Three.js"&gt;&lt;/script&gt;
     &lt;script src="../libs/RequestAnimationFrame.js"&gt;&lt;/script&gt;
     &lt;script&gt;

     var renderer = null,
          scene = null,
          camera = null,
          cube = null,
          animating = false;

     function onLoad()
     {
        // 抓取作为Canvas容器的&lt;div&gt;标签
        var container = document.getElementById("container");
        // 创建Three.js渲染器，并添加到&lt;div&gt;标签中
        renderer = new THREE.WebGLRenderer( { antialias: true } );
        renderer.setSize(container.offsetWidth, container.offsetHeight);
        container.appendChild( renderer.domElement );
        // 创建Three.js场景
        scene = new THREE.Scene();
        // 创建相机，并添加到场景中
        camera = new THREE.PerspectiveCamera( 45,
            container.offsetWidth / container.offsetHeight, 1, 4000 );
        camera.position.set( 0, 0, 3 );
        // 创建一个平行光光源照射到物体上
        var light = new THREE.DirectionalLight( 0xffffff, 1.5);
        light.position.set(0, 0, 1);
        scene.add( light );
        // 创建一个接受光照并带有纹理映射的立方体，并添加到场景中
        // 首先，创建一个带纹理映射的立方体
        var mapUrl = "../images/molumen_small_funny_angry_monster.jpg";
        var map = THREE.ImageUtils.loadTexture(mapUrl);

        // 然后创建一个Phong材质来处理着色，并传递给纹理映射
        var material = new THREE.MeshPhongMaterial({ map: map });
        // 创建一个立方体的几何体
        var geometry = new THREE.CubeGeometry(1, 1, 1);
        // 将几何体和材质放到一个网格中
        cube = new THREE.Mesh(geometry, material);
        // 设置网格在场景中的朝向，否则我们将不会看到立方体的形状！
        cube.rotation.x = Math.PI / 5;
        cube.rotation.y = Math.PI / 5;
        // 将立方体网格添加到场景中
        scene.add( cube );
        // 添加处理鼠标事件的函数，用于控制动画的开关
        addMouseHandler();
        // 运行渲染循环
        run();
     }
     function run()
     {
          // 渲染场景
          renderer.render( scene, camera );
          // 在下一帧中旋转立方体
          if (animating)
          {
               cube.rotation.y -= 0.01;
          }
          // 在另一帧中回调
          requestAnimationFrame(run);
     }
     function addMouseHandler()
     {
          var dom = renderer.domElement;

          dom.addEventListener( 'mouseup', onMouseUp, false);
     }

     function onMouseUp  (event)
     {
         event.preventDefault();
         animating = !animating;
     }

     &lt;/script&gt;
&lt;/head&gt;
&lt;body onLoad="onLoad();" style=""&gt;
   &lt;center&gt;&lt;h1&gt;Welcome to WebGL!&lt;/h1&gt;&lt;/center&gt;
   &lt;div id="container"
       style="width:95%; height:80%; position:absolute;"&gt;
   &lt;/div&gt;
   &lt;div id="prompt"
      style="width:95%; height:6%; bottom:0; position:absolute;"&gt;
   Click to animate the cube
   &lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;
</code></pre>
<p>除去我稍后会详细介绍的一些设置内容和添加了一个CSS样式表来控制字体和颜色之外，这段程序的开头部分和我们之前的那个示例非常相似。我们创建了Three.js渲染器对象，并将其DOM元素作为Canvas容器的子元素加入。这一次我们给构造函数传递了一个名为antialias的参数，并将其设置为true，告诉Three.js要启用抗锯齿（antialiased）渲染。抗锯齿可以避免绘制物体边缘时产生的锯齿。（在Three.js中有很多给方法传递参数的方式。通常来说，在对象中传递构造函数参数都是使用被命名的字段，正如在本示例中这样。）然后，我们创建了一个带透视效果的相机，和之前的示例一样。但这次，相机稍微移动了一些，以便我们可以更近地观察立方体。</p>
<p><strong>2.4.1　为场景着色</strong><br />
我们马上就可以在场景中添加立方体了。如果往前看几行，你会发现我们使用了Three.js内置的CubeGeometry对象来创建一个单位体积的立方体。但在添加立方体之前，我们还需要做其他的一些事情。首先，我们需要对场景进行着色（shading）。如果没有着色，你将无法分辨出立方体表面的边界。我们还需要创建一个纹理映射来渲染到立方体表面，稍后会详细介绍。</p>
<p>为了将着色效果添加到场景中，我们需要做两件事：添加一个光源和使用另一种不同的材质。在Three.js中有好几种不同的光源。在我们的示例中，将会使用平行光（directional light），这是一种从无限远的距离（光源没有特定的位置）照向指定方向的光。Three.js的语法有些奇怪，我们要做的不是设置光源的照射方向，而是要使用position属性设置光源距离原点的位置；由此可以推论出，光源的照射方向就成了从该点指向场景原点（即照射到我们的立方体上）。</p>
<p>我们要的第二件事就是改变使用的材质。在Three.js中，MeshBasicMaterial用于定义属性简单的材质，比如固定颜色或是透明。这种材质不会对光照做出任何响应。所以我们要用另一种类型的材质来代替它，这就是MeshPhongMaterial。这种类型的材质应用了一种相对简单、仿真度高而又性能优越的着色模型，也就是著名的“Phong着色法”（Phong shading）。（Three.js同时还支持其他更加复杂的着色模型，我们之后会讲到。）使用了Phong着色法，我们现在就可以分辨出立方体的边缘。立方体朝向光源方向的面将会更加明亮；而背对光源的面则会相对阴暗。由此，我们即可分辨出面与面之间的边界。</p>
<p>图片 3 也许你已经发现了，在这个章节中我所提到的都是着色，而不是我们在第1章中提到的着色器。这是因为，我们之前说过着色器其实是一小段用类C语言写成的代码，而Three.js已经为我们内置了这样的着色器。我们只要简单的设置光源和材质，Three.js就可以用内置的着色器来替我们处理剩下的脏活累活。感谢Three.js的作者，感谢Mr.doob！</p>
<p><strong>2.4.2　添加纹理映射</strong><br />
纹理映射（texture map），也被称为纹理（texture），是一种将位图覆盖到3D网格表面的技术。使用纹理映射可以通过简单的方式定义网格表面的颜色，同时也可以通过纹理图片的组合应用创造出更加复杂的效果，如凹凸效果和高光效果。WebGL提供了一些API调用来处理纹理，同时因为安全原因，限制了诸如跨域纹理的使用（详细信息参见第7章）。幸运的是，在Three.js中我们只要使用简单的API就可以载入纹理并与材质绑定在一起，而不需要处理太多的琐事。我们调用THREE.ImageUtils.loadTexture()方法来从一个图片文件载入纹理，然后通过向材质的构造函数传递map参数，把处理后的纹理与材质相关联。</p>
<p>在这里，Three.js替我们完成了很多的底层工作。它会把JPEG图像正确的映射到立方体的各个面上，并保证图像不会拉伸覆盖所有面，同时在各个面上的图像不会出现翻转或者倒立的错误。也许看起来这并不是什么大事情，但是如果你亲自用WebGL原生API来完成这件事的话，你会发现需要处理的细节太多了。而Three.js再一次替我们完成了这些困难的工作，它用内置的Phong着色器结合光源的设置、材质颜色和纹理映射的像素值，使得最终每个像素上都显示正确的颜色，并形成最后的图像效果。在Three.js中，我们可以使用纹理映射做很多事情。我们将会在随后的章节中详细讨论更多细节。</p>
<p>现在可以开始创建我们的立方体网格了。我们构造了一个几何体、材质和纹理，然后把它们都放到一个Three.js的网格中，并存储在变量cube中。示例2-3列出了用于创建带光照效果、纹理和Phong着色的立方体的代码。</p>
<p>示例2-3　创建带光照效果、纹理和Phong着色的立方体</p>
<pre><code>// 创建照射物体的平行光光源
var light = new THREE.DirectionalLight( 0xffffff, 1.5);
light.position.set(0, 0, 1);
scene.add( light );
// 创建一个带着色效果和纹理映射的立方体，并添加到场景中
// 首先，创建纹理映射
var mapUrl = "../images/molumen_small_funny_angry_monster.jpg";
var map = THREE.ImageUtils.loadTexture(mapUrl);
// 然后创建一个Phong着色材质，并与纹理关联
var material = new THREE.MeshPhongMaterial({ map: map });
// 创建一个立方体的几何体
var geometry = new THREE.CubeGeometry(1, 1, 1);
// 将几何体和材质放入同一个网格中
cube = new THREE.Mesh(geometry, material);
</code></pre>
<p><strong>2.4.3　旋转物体</strong><br />
图片 3在我们能看到立方体之前，还需要做一件事，那就是稍微旋转一下它。否则我们永远也不会发现这是一个立方体，因为它会端正地用一个面朝向我们，看起来就和我们在之前的示例中画的那个正方形一模一样，只是多了纹理贴图。所以让我们把它朝相机方向绕着x轴（水平方向）翻转一些。我们是通过设置网格的rotation属性来完成的。在Three.js中，每个物体都有位置（position）、旋转（rotation）和缩放（scale）属性。（还记得吗？我们在之前的示例中，把相机往后移动了一些。）通过给rotation.x赋一个非零值，我们告诉Three.js去为物体绕着x轴做当量的旋转。同理我们也以此处理y轴，让立方体稍微向左旋转一下。这样一来，我们就可以看到立方体6个面中的3个了。</p>
<p>在为物体的旋转变量赋值时，我们需要注意，大部分的3D图形系统都使用了弧度制（radians）来度量角度。弧度是指单位圆上相应角度的圆弧长度（例如，弧度制的2π就是角度制的360°）。Math.PI相当于180°，因此当我们赋值mesh.rotation.x = Math.PI / 12的时候，实际上是绕着x轴旋转了15°。</p>
<p><strong>2.4.4　循环重绘和requestAnimationFrame()</strong><br />
你也许已经发现这个示例与之前的那个在结构上有些不同。首先，我们增加了一些辅助性的函数。其次，我们定义了一些全局变量来存储那些将用于辅助性函数的值。（好吧，我知道，这样滥用全局变量又是一个不好的习惯。但就像我承诺过的一样，在下一章我们将会应用框架结构。）同时我们还增加了一个循环函数，这就是所谓的循环重绘。通过循环重绘，我们不再只渲染一次场景，而是持续不断地渲染。这对于静态场景并不重要，但是对于含有运动物体或响应用户输入而发生变化的场景来说，我们需要持续不断地渲染场景。从现在开始，我们以后所有的示例都将使用循环重绘来渲染场景。</p>
<p>有很多方法来应用循环重绘。一种方法就是使用setTimeout()回调，每当场景渲染完毕后就重置超时时差。这也是一种经典的Web开发技巧，用于制作动态效果；然而它的确已经过时了，因为新的浏览器都支持一种更好的方法，那就是requestAnimationFrame()。这个函数被专门设计用于制作页面动画，当然也包括WebGL中的动画。</p>
<p>使用requestAnimationFrame()，浏览器可以极大地优化动画的性能表现。因为它会综合考虑所有的绘制请求，把它们都放到同一个重绘步骤中。尤其在多标签浏览器中，当动画页面处于后台时，浏览器将停止重绘以节省资源提高性能。不过并不是所有版本的所有浏览器都支持这个函数；更加添乱的是，每个浏览器中这个函数的函数名都不一样。因此，我引入了一个漂亮的工具：由Paul Irish编写的RequestAnimation　Frame.js。这个文件会掩盖不同浏览器的差异性，开发者只要简单地使用requestAnimationFrame()即可。</p>
<p>我们已经准备好要开始渲染场景了。我们定义了一个函数run()，负责进行循环重绘。和之前一样，我们调用了渲染器的render()方法，将场景和相机传递给它。然后，我们写了一小段逻辑代码让立方体可以动起来。我们将会在下一节详细介绍。最后我们让浏览器继续渲染下一帧。参见示例2-4。</p>
<p>示例2-4　循环重绘</p>
<pre><code>function run()
{
// 渲染场景
renderer.render( scene, camera );
// 为下一帧旋转立方体
if (animating)
{
    cube.rotation.y -= 0.01;
}
// 请求下一帧
requestAnimationFrame(run);
}
</code></pre>
<p>你可以在图2-2中看到最后的运行效果。现在你可以看到立方体的前侧和顶部。我们终于在页面上显示了一个真正的3D物体！</p>
<p><strong>2.4.5　让页面贴近生活</strong><br />
作为第一个完整的示例，我们原本可以到此就结束了。我们已经在页面上绘制了一个漂亮的图形，而且是真正的3D图形。但是在今天，3D图形不只是和渲染有关了，它还需要动画和交互性。如果没有动画和交互，开发者只需要让做3D美术建模的朋友在Max和Maya中渲染好之后，存为图片然后用 标签嵌入网页就好，何必还折腾什么WebGL呢？这不是我们想要的。因此在这种思想的指导下，即使是一个简单的示例，我们也要为它加入动画和交互。</p>
<p>在之前的小节中，我们讨论了循环重绘。这就是我们在渲染下一帧之前改变场景的机会。为了旋转这个立方体，我们需要在每一帧都改变它的旋转属性值。我们不想让它随机乱转，而是一个绕着y轴平滑的旋转，所以我们需要做的就是每过一段时间就给它的旋转的y值做适度的增量。在WebGL中，这是一种相对简单的制作动画效果的思路。当然，还有其他的方法，但都更加复杂。我们会在以后的章节中介绍。</p>
<p>最后，如果我们可以控制立方体的旋转那就再好不过了。我们已经添加了一个处理鼠标点击的函数，直接使用了DOM的事件方法。其中有一个需要指出的小技巧就是，在这个示例中我们使用的DOM元素是和Three.js中渲染器对象关联的。具体的代码参考示例2-5。</p>
<p>示例2-5　添加鼠标交互</p>
<pre><code>function addMouseHandler()
{
    var dom = renderer.domElement;
    dom.addEventListener( 'mouseup', onMouseUp, false);
}
function onMouseUp    (event)
{
    event.preventDefault();
    animating = !animating;
}
</code></pre>
<p>点击立方体吧！看着它旋转！是不是很沉浸其中呢？</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-03 16:49:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8f%e8%a7%88%e5%99%a8/" title="浏览器">浏览器</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/webgl/" title="webgl">webgl</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《WebGL入门指南》——第2章，第2.4节一个真实的3D示例的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mrq6Pxb.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第1章，第1&period;4节本章小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 本章小结 WebGL入门指南 这样我们就结束了WebGL基础知识之旅.噢!东西可真多啊!现在你也许在想,仅仅在屏幕上画一个正方形就如此兴师动众.而且,这还不是一个真正的3D物体!好吧,我部分同意你的意见.WebGL编程,在这个等级上的编程,是相当困难的.标准的设计者做出这样一个决定还是相当清醒的,他们用这样一个既小巧又简单的标准,换取了WebGL强大的能力,而付出的代价是开发者必须要在应用程序端编写大量的代码. 显然,在大部分情况下,我们不会使用WebGL来绘制2D物体.HTML5的2D			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bod1W6M.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第2章，第2&period;3节一个简单的Three&period;js网页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 一个简单的Three.js网页 WebGL入门指南 好了,我想现在是时候来编写你的第一个 WebGL 程序了.在这一节中,你会看到上手Three.js是一件相当简单的事情.示例2-1实际上是第1章中的那个绘制正方形示例的翻版,但是将代码从150行精简到30行.由此可见,在使用Three.js之后对代码的压缩量之大. 示例2-1 一个简单的Three.js网页 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;title&gt;A Simple			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeoeO7M.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第2章，第2&period;5节本章小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.5 本章小结 WebGL入门指南 本章介绍了第一个真实示例.我必须要说,这其实还是很轻松的.仅仅使用了很少的代码,我们就可以创建一个包含3D内容的HTML网页,装扮它,用动画赋予它生命,然后让它可以交互.你要意识到在过去这是根本不可能的.感谢WebGL,让这一切都变成了现实.而又有了Three.js,可以让你在开发前不必先去考取一个计算机图形学的学位. 我们已经构建和运行起来了WebGL,剩下的就都是细节了.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myd2A8b.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第1章，第1&period;2节3D图形学&mdash;&mdash;入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 3D图形学--入门 WebGL入门指南 &quot;数学太难了啦!&quot; --芭比娃娃 也许有点不太好听,但是我必须得说,当我写3D图形的代码的时候,我会和芭比一样,有强烈的欲望想要用疯狂购物来放纵一下自己.因为3D图形编程通常很难,而且需要大量的数学知识.幸运的是,你不需要先成为数学大师再来写WebGL应用:我们会使用各种框架来代替我们去做其中大部分的复杂工作.尽管如此,理解底层的工作原理依然是非常重要的,因此下面我尝试在几页的篇幅内总结出整个3D图形学的基础知识. 1.2.1 3D坐标系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJA9k6p.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第2章，第2&period;1节Three&period;js&mdash;&mdash;一个JavaScript 3D引擎</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.1 Three.js--一个JavaScript 3D引擎 WebGL入门指南 需求是创新之母.每个开发者在项目之初都必须不厌其烦的使用WebGL原生API来编写代码,直到可以建立一个自己的代码库,以用于随后的通用3D编程.事实上,已经有很多人完成了这项工作.现在有很多不错的WebGL开源框架,例如GLGE(http://www.glge.org/).SceneJS(http://www.scenejs.org/).CubicVR(http://www.cubicvr.org/)等.每个框架			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlLYrLM.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第1章，第1&period;3节WebGL原生API</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 WebGL原生API WebGL入门指南 计算机图形学中的基本概念在过去的数年中从未发生过变化.但图形技术却不断进化,特别是最近几年,伴随着设备和操作系统的多样化.这些百花齐放的图形技术的根基则是诞生于20世纪80年代末期的OpenGL.OpenGL作为行业规范已经存在了非常长的时间,并且成功经受住了来自微软的DirectX的竞争考验,无可争辩的成为了3D图形编程的领衔者. 但是并非所有的OpenGL都是一样的.根据不同平台的不同特征,包括台式电脑.智能电视.手机和平板电脑等,人们开发了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx0V1PM.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第1章，第1&period;1节WebGL&mdash;&mdash;一个技术定义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1 WebGL--一个技术定义 WebGL入门指南 WebGL 标准是由科纳斯组织(Khronos Group)开发和维护的,该组织还是管理着 OpenGL.COLLADA等其他你也许早有耳闻的规范的标准组织.以下是科纳斯组织的网站上对WebGL的官方描述: WebGL是免授权费的,跨平台的应用程序接口API,它将OpenGL ES 2.0作为在HTML网页内的3D绘图环境,作为低级别文档对象模型接口开放.它使用OpenGL渲染语言GLSL ES,并可被整洁地与其他3D内容上层或下层的网页内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyeBY4M.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;第2章，第2&period;2节建立Three&period;js运行环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 建立Three.js运行环境 WebGL入门指南 你要做的第一件事情就是从GitHub上获取到最新版的Three.js包.Three.js在GitHub上的地址是https://github.com/mrdoob/three.js/.复制到本地之后,你可以在build/Three.js目录找到打包好的库文件.另外,Three.js的全部源代码都在src文件夹中.而API文档则是直接连接到GitHub网站,但这份文档相当简陋,你最好还是对照源代码来上手. Three.js使用了Google			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLaqVRz.html" rel="bookmark">《WebGL入门指南》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目 录第1章 WebGL简介 1.1 WebGL--一个技术定义 1.2 3D图形学--入门 1.3 WebGL原生API 1.4 本章小结 第2章 你的第一个WebGL程序 2.1 Three.js--一个JavaScript 3D引擎 2.2 建立Three.js运行环境 2.3 一个简单的Three.js网页2.4 一个真实的3D示例 2.5 本章小结 第3章 图形 第4章 动画 第5章 交互 第6章 2D与3D的整合 第7章 实战WebGL 第8章 你的第一个WebGL游戏 后记 附录A			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0gvnb.html" rel="bookmark" class="title">中国餐饮娱乐网&amp;amp&semi;nbsp&semi;设计推广计划书</a>
					<div>
						设计|推广 一  餐饮行业联手网站营销的市场分析: 随着社会的脚步加速,人们对时间越来越看重,而网络的普及率越来越高,相比繁琐的寻找合适的就餐地点而言,网商定餐越来越受人们的欢迎,尤其是高品位生活的白 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg696b.html" rel="bookmark" class="title">纯文本链接如何做有助于关键词排名</a>
					<div>
						大家都知道,外链按点击分也就分为两种,一种是能点击的,一种是不能点击的.记得前2年有一种说法得到大多数人的认同:锚文本有助于该关键词的排名,网址链接及纯文本网址可以增加网站的整体权重,其中纯文本网址效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ8dJM.html" rel="bookmark" class="title">高质量外链建设必须遵循的五大原则</a>
					<div>
						相信很多seo都明白外部链接的重要性.在笔者看来,seo其实就是内容和链接,内容这里笔者就不讲诉了.链接主要分为站内链接和外部链接,这里笔者不要强调外部链接建设,相信很多站长朋友们都在努力建设外部链接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zG4VEb.html" rel="bookmark" class="title">关于释放session的两篇文章（二）</a>
					<div>
						session Deleting a Subset of Session Variables When using Sessions to store variables in, I use a na ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeG8jM.html" rel="bookmark" class="title">&period;NET 程序，调用其它程序</a>
					<div>
						程序 .NET 程序,调用其它程序 using System;using System.Diagnostics; namespace Jmv_Demo{ /// &lt;summary&gt; /// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zON9Qp.html" rel="bookmark" class="title">长尾关键词应根据网站权重来挖掘与扩展</a>
					<div>
						长尾关键词每天给网站带来的流量是不可预估的,虽然没有目标关键词来的那么多,但是从转化率方面来看,长尾关键词的&quot;有效性&quot;要比很多目标关键词要大,作为长尾关键词这块,我觉得应该根据网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3eRJp.html" rel="bookmark" class="title">大规模公有云的自动化工具</a>
					<div>
						云计算已经不仅仅是虚拟基础设施的快速自助式服务.开发者和管理员正在寻求规模化云计算的供应和管理方法.这篇InfoQ文章是关于动态计算资源池维护的自动化工具和理念系列的其中一篇.可以通过这里订阅这一系列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyNL4p.html" rel="bookmark" class="title">在C&num;中获取页面元素布局信息的代码</a>
					<div>
						最近研究一个如何在网页定位验证码并截图的问题时, 用SS写了一段C#小脚本可以轻松获取页面任 意元素的布局信息 (top, left, width, height). 10行功能代码, 觉得有点用,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPPnQz.html" rel="bookmark" class="title">网络中的Ajax&colon;在Ajax架构中聚合来自多个站点的内容所面临的安全性和拓扑问题</a>
					<div>
						在试图将 Asynchronous JavaScript and XML (Ajax) 编程技术引入到网络环境中时,常常会遇到一些困难. 简介 Ajax 架构一个让人兴奋的特性就是能够聚合来自多个数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNXADb.html" rel="bookmark" class="title">NBearV3教程&mdash;&mdash;实体配置文件加密篇</a>
					<div>
						版本 1.0 [2006-11-18] 简介 本教程介绍NBearV3中的实体配置文件的加密支持. 目标 通过本教程,读者应能够全面掌握加密实体配置文件和如何结合使用ASP.NET的配置节加密功能,实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5A237p.html" rel="bookmark" class="title">Asp&period;net MVC示例项目&OpenCurlyDoubleQuote;Suteki&period;Shop&rdquo;分析之数据验证</a>
					<div>
						在Suteki.Shop,实现了自己的数据校验机制,可以说其设计思路还是很有借鉴价值的.而使用这种 机制也很容易在Model中对相应的实体对象(属性)添加校验操作方法.下面就来介绍一下其实现方式. 首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62mKyM.html" rel="bookmark" class="title">如何用PS给照片换底色</a>
					<div>
						    如何用PS给照片换底色 双击ps图标,打开ps软件,如下图所示. 打开图片,[ctrl+o],在对话框里选一张素材图片,如下图所示. 复制图层,[ctrl+j],因为我们要在复制的图层上操作, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPZZjM.html" rel="bookmark" class="title">实现PHP&plus;Mysql无限分类的方法汇总</a>
					<div>
						 这篇文章主要给大家汇总介绍了实现PHP+Mysql无限分类的2种方法,并对比分析了2种方法的优劣,需要的朋友可以参考下     无限分类是个老话题了,来看看PHP结合Mysql如何实现. 第一种方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlv8Ob.html" rel="bookmark" class="title">WPS中删除线轻易加</a>
					<div>
						  很多朋友都用上了WPS2013,它与WP2003区别还是挺大的,很多的常用键如果不熟悉界面的用户,根本就找不着.不知你是否也是这样.没关系慢慢来学,毕竟要有一段时间的适应期,接下来,就由小编来讲述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZ1G7z.html" rel="bookmark" class="title">如何用Word2003来制作中国棋图</a>
					<div>
						  如何用Word2003来制作中国棋图 如何用Word2003来制作中国棋图,中国象棋在中国有着悠久的历史,属于二人对抗性游戏的一种.由于用具简单,趣味性强,成为流行极为广泛的棋艺活动.下面将教你如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjm08mz.html" rel="bookmark" class="title">设计模式之建造者模式与工厂方法模式</a>
					<div>
						    建造者模式:                将一个复杂对象的构建与它的表示分离,使得同样的构建过程可以创建不同的表示.     建造者模式结构图:                     产品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQmemz.html" rel="bookmark" class="title">继承-java中a是b的父类，b是c的父类，那a是c的父类吗</a>
					<div>
						问题描述 java中a是b的父类,b是c的父类,那a是c的父类吗 java中a是b的父类,b是c的父类,那a是c的父类吗 子类继承父类,是不是共享了父类的所有变量和方法,即使子类没有重写或者重载,可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQQqLp.html" rel="bookmark" class="title">vc&plus;&plus;-win7 64位下建立MFC工程不行</a>
					<div>
						问题描述 win7 64位下建立MFC工程不行 每次建立MFC工程总是提示&quot;fatal error RC1015:cannot open include file 'afxeres.h'.& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrrwaM.html" rel="bookmark" class="title">android框架层如何取到应用层的数据</a>
					<div>
						问题描述 android框架层如何取到应用层的数据 解决方案 楼上乱说,是通过binder机制来传递数据的,楼主网上搜索android binder机制解决方案二:可以使用Intent实现数据传递					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1llGjb.html" rel="bookmark" class="title">android webview-android的webview点击超链接，页面多次跳转</a>
					<div>
						问题描述 android的webview点击超链接,页面多次跳转 android的webview点击一个超链接,在shouldOverrideUrlLoading中拦截到多个url,但最后一个url才 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQdWLp.html" rel="bookmark" class="title">金融安全资讯精选 2017年第十一期 银行木马利用VMvare进行传播 研究人员发现新型安卓银行木马Red Alert</a>
					<div>
						[金融安全动态] 银行木马利用VMvare进行传播 点击查看原文 概要:思科的研究团队Talos近日发现一起针对对南美巴西的银行木马活动.该木马活动的对象主要是南美的银行,通过窃取用户的证书来非法获利 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NPB9M.html" rel="bookmark" class="title">智能手机病毒解析</a>
					<div>
						在忙碌的现代生活中,手机不仅是人与人交往的工具,更成为人与社会联系的纽带.每天24小时手机不离左右,已经成为很多人的生活习惯.这些手掌般大小的电子设备,渐渐成了日常生活中人们的&quot;最佳拍档&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlGQmp.html" rel="bookmark" class="title">MS SQL 数据库状态为SUSPECT的处理方法</a>
					<div>
						当SQL SERVER数据库状态为质疑(SUSPECT)状态时,我们可以用以下方法来处理: 1. 修改数据库为紧急模式:ALTER DATABASE DBName SET EMERGENCY . 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBd2Db.html" rel="bookmark" class="title">奥迪CVT变速箱故障频发：时速100公里A6L突变空挡失动力</a>
					<div>
						车才开两个月,郑州车主原先生的一汽奥迪A6L去年9月便在高速路上出现了惊险一幕:时速100公里时突然车变空挡失去动力,发动机怠速忽高忽低,仪表盘上显示&quot;变速箱故障,您可以继续驾驶&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Rk6Dz.html" rel="bookmark" class="title">Facebook申请专利 或让好友及陌生人相互拼车</a>
					<div>
						全球最大社交网络Facebook,移动出行及拼车--这两个事物似乎没有交集.而据外媒消息,Facebook之前申请的一个专利近日被公开,显示Facebook可能利用社交网络亲朋好友信息聚合的优势,推出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eYK9b.html" rel="bookmark" class="title">ListView嵌套在TabActivity里数据不更新解决办法</a>
					<div>
						 ListView嵌套在TabActivity里数据不更新解决办法(暂时解决问题):   TabHost tabHost = getTabHost();      tabHost.addTab(tab ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xWKRb.html" rel="bookmark" class="title">很多网民喜欢搜索自己</a>
					<div>
						据皮尤研究中心发表研究报告称,大约有57%的美国成年网民在搜索引擎中喜欢输入自己的名字,用于评估自己在网络世界的声誉. 这一数字自开始以来有了较大的增长幅度,早在2006年时这一比例仅为47%.报告指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeovoxM.html" rel="bookmark" class="title">百亿元网络信息安全母基金成立</a>
					<div>
						昨天上午,在北京市委宣传部支持下,北京日报报业集团联合中信建投证券股份有限公司.金汇金投资集团共同发起设立的网络信息安全母基金启动仪式在京举行.据了解,母基金总规模100亿元,专注投资网络信息安全领域 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEmGAz.html" rel="bookmark" class="title">解析&colon;继承ViewGroup后的子类如何重写onMeasure方法&lowbar;Android</a>
					<div>
						1.首先贴上我试验成功的代码 复制代码 代码如下: protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6G4mJp.html" rel="bookmark" class="title">陌陌的营销术</a>
					<div>
						&quot;不要和陌生人说话,别做新鲜事,过平常的生活.胆子小一点,不要太好奇,就玩你会的,远离冒险的,有些事想想就好,不一定 非要改变.待在熟悉的地方,特别是待在家里 ,听一样的音乐,见一样的人.重 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
